/**
 * Copyright 2015 Lorentz Lasson
 * Copyright 2015, 2016 Lorentz Lasson, Dave Conway-Jones
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 **/

module.exports = function(RED) {
    function PlayAudioNode(config) {
        RED.nodes.createNode(this,config);
        var node = this;
        this.on('input', function(msg) {
            if (Buffer.isBuffer(msg.payload)) {
                RED.comms.publish("playaudio", msg.payload);
            }
            else if (typeof msg.payload === "string") {
                RED.comms.publish("playtts", msg.payload);
            }
        });
    }
    RED.nodes.registerType("play audio", PlayAudioNode);
}
